(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      4005,        132]*)
(*NotebookOutlinePosition[      4648,        154]*)
(*  CellTagsIndexPosition[      4604,        150]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Calling a DLL Function Using .NET/Link", "Title"],

Cell[TextData[{
  ".NET/Link lets you call functions from old-style DLLs by just declaring \
the function in a single line of ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " code. That's right--you no longer need to deal with ",
  StyleBox["MathLink",
    FontSlant->"Italic"],
  ", write template files, or come anywhere near a C compiler.\n\nIn this \
exercise, call the strcmp() function from the C runtime library. The C \
runtime library is provided as a DLL called msvcrt.dll on Windows machines. \
This isn't the most useful DLL function to call, but at least it's in a DLL \
that everyone is certain to have on their machines."
}], "Text"],

Cell["Here is the C-language prototype for the strcmp() function:", "Text"],

Cell[TextData[{
  StyleBox["int",
    FontWeight->"Bold"],
  " ",
  StyleBox["strcmp(",
    FontWeight->"Bold"],
  " ",
  StyleBox["const",
    FontWeight->"Bold"],
  " ",
  StyleBox["char",
    FontWeight->"Bold"],
  StyleBox[" *",
    FontWeight->"Bold"],
  StyleBox["string1",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[", const char *",
    FontWeight->"Bold"],
  StyleBox["string2",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  StyleBox[" ",
    FontWeight->"Bold"],
  StyleBox[");",
    FontWeight->"Bold"],
  " "
}], "Program"],

Cell["<<NETLink`", "Input"],

Cell[TextData[{
  "Use DefineDLLFunction to create a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " function that knows how to call a DLL function. The basic form is:\n\n    \
",
  StyleBox["   func = DefineDLLFunction[\"funcName\", \"DLLname\", \
\"returnType\", {\"argType1\", \"argType2\", ...}]\n   \n     func[arg1, \
arg2]", "Input"]
}], "Text"],

Cell["\<\
You can use most C type names as return types and argument types. Remember \
that the DLL name is msvcrt.dll.\
\>", "Text"],

Cell["\<\


After you are done with strcmp(), call the _lrotl() function, also found in \
msvcrt.dll. See if it gives the same results as Developer`BitShiftLeft. Here \
is the prototype:\
\>", "Text"],

Cell[TextData[StyleBox["unsigned long _lrotl( unsigned long value, int shift \
); ",
  FontWeight->"Bold"]], "Program"]
}, Open  ]]
},
FrontEndVersion->"5.1 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
WindowSize->{782, 653},
WindowMargins->{{9, Automatic}, {7, Automatic}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 55, 0, 95, "Title"],
Cell[1834, 55, 658, 13, 128, "Text"],
Cell[2495, 70, 75, 0, 33, "Text"],
Cell[2573, 72, 559, 27, 43, "Program"],
Cell[3135, 101, 27, 0, 30, "Input"],
Cell[3165, 103, 363, 9, 112, "Text"],
Cell[3531, 114, 133, 3, 33, "Text"],
Cell[3667, 119, 200, 6, 90, "Text"],
Cell[3870, 127, 119, 2, 43, "Program"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

